// C/C++ File
// AUTHOR:   foton
// FILE:     main.c
// ROLE:     to rule them all
// CREATED:  2017-01-30 21:51:28
// MODIFIED: 2017-02-13 20:30:48

#include "fdf.h"

void	swap_x_y(t_point *p1, t_point *p2)
{
	int temp;

	temp = p1->x;
	p1->x = p1->y;
	p1->y = temp;
	temp = p2->x;
	p2->x = p2->y;
	p2->y = temp;
}

void	swap_points(t_point *p1, t_point *p2)
{
	t_point temp;

	temp = *p1;
	*p1 = *p2;
	*p2 = temp;

}

void	draw_line(t_point *p1, t_point *p2, t_mlx *m, t_swap *s)
{
	int dx = abs(p2->x - p1->x);
	int dy = abs(p2->y - p1->y);
	int derr = 2 * dy - dx;
	while (p1->x < p2->x)
	{
		if (s->swap_coord)
			mlx_pixel_put(m->mlx, m->win, p1->y, p1->x, p1->color);
		else
			mlx_pixel_put(m->mlx, m->win, p1->x, p1->y, p1->color);
		if (derr > 0)
		{
			p1->y += s->swap_x;
			derr -= dx;
		}
		(p1->x)++;
		derr += dy;
	}
}

void	line(t_point *p1, t_point *p2, t_mlx *m)
{
	int dx;
	int dy;
	t_swap swap;

	dx = abs(p2->x - p1->x);
	dy = abs(p2->y - p1->y);
	swap.swap_coord = 0;
	swap.swap_x = 1;
	if (dy > dx)
	{
		swap_x_y(p1, p2);
		swap.swap_coord= 1;
	}
	if (p1->x > p2->x)
	{
		swap_points(p1, p2);
	}
	if (p1->y > p2->y)
	{
		swap.swap_x = -1;
	}
	draw_line(p1, p2, m, &swap);
}

void	test_line(t_mlx mlx)
{
	t_point p1;
	t_point p2;
	int		temp;

	p1.color = 0xC100E5;
	p2.color = 0xC100E5;
	for (p2.y = 0; p2.y <= 500; p2.y += 4)
	{
		p1.x = 0;
		p1.y = 0;
		p2.x = 500;
		line(&p1, &p2, &mlx);
	}
	for (p2.x = 500; p2.x >= 0; p2.x -= 4)
	{
		p1.x = 0;
		p1.y = 0;
		p2.y = 500;
		temp = p2.x;
		line(&p1, &p2, &mlx);
		p2.x = temp;
	}
	p1.color = 0x1EBF00;
	p2.color = 0x1EBF00;
	for (p2.y = 0; p2.y <= 500; p2.y += 4)
	{
		p1.x = 500;
		p1.y = 0;
		p2.x = 0;
		temp = p2.y;
		line(&p1, &p2, &mlx);
		p2.y = temp;
	}
	for (p2.x = 0; p2.x <= 500; p2.x += 4)
	{
		p1.x = 500;
		p1.y = 0;
		p2.y = 500;
		temp = p2.x;
		line(&p1, &p2, &mlx);
		p2.x = temp;
	}
}

void	circle(t_mlx m)
{
	t_point	p1;
	t_point	p2;
	double angle;


	p1.color = 0xFFFFFF;
	p2.color = 0xFFFFFF;
	for (int i = 0; i < 360; i += 4)
	{
		p1.x = 250;
		p1.y = 250;
		angle = i * M_PI / 180;
		p2.x = p1.x + 200 * sin(angle);
		p2.y = p1.y + 200 * cos(angle);
		line(&p1, &p2, &m);
	}
}


int		main(int argc, char **argv)
{
	t_mlx	m;
	int 	fd;
	char 	*line;

	if (argc != 2)
		return (0);
	fd = open(argv[1], O_RDONLY);
	// add new get_next_line
	while (get_next_line(fd, &line))
	{
		ft_putstr(line);
		ft_putstr("\n");
	}
	m.mlx = mlx_init();
	m.win = mlx_new_window(m.mlx, 500, 500, "fdf");
	//line(&p1, &p2, &m);
	test_line(m);
	circle(m);
	mlx_loop(m.mlx);
	return (0);
}
